#
#  Copyright (C) 2013  Thadeu Lima de Souza Cascardo <cascardo@holoscopio.com>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 3 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License along
#  with this program; if not, write to the Free Software Foundation, Inc.,
#  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
#

import urllib2
import urllib
import re

class VisaVale():
	def __init__(self, cartao, periodo=0):
		self._URL = "http://www.cartoesbeneficio.com.br/inst/convivencia/SaldoExtrato.jsp"
		self._form = { 'numeroCartao': cartao, 'periodoSelecionado': periodo }
		self._r = re.compile("Saldo disp.*(R\$ [0-9,]*)")
		self._d = re.compile("<td.*>(../..)</td>")
		self._i = re.compile("<td.*400px.*>(.*)</td>")
		self._v = re.compile("<td.*>(R\$.*)</td>")
	def _normalize(self, value):
		_int = re.search("([0-9]*),", value).group(1)
		_dec = re.search(",([0-9]*)", value).group(1)
		return int(_int) + int(_dec) / 100.00
	def run(self):
		self._h = urllib2.urlopen(self._URL, urllib.urlencode(self._form), 15)
		self._s = self._h.read()
		self._saldo = self._normalize(self._r.search(self._s).group(1))
		self._datas = self._d.findall(self._s)[1:]
		self._itens = self._i.findall(self._s)[1:]
		self._valores = map(self._normalize, self._v.findall(self._s)[:-1])
	def saldo(self):
		return self._saldo
	def extrato(self):
		return zip(self._datas, self._itens, self._valores)
